Properties Methods Events Config Options Direct Link

# Class Ext.data.Field

Package: | Ext.data
Defined In: | DataField.js
Class: | Field
Extends: | Object

This class encapsulates the field definition information specified in the field definition objects passed to Ext.data.Record.create.

Developers do not need to instantiate this class. Instances are created by Ext.data.Record.create and cached in the fields property of the created Record constructor's prototype.

## Config Options

Config Options | Defined By
--- | ---
| allowBlank : Boolean Used for validating a record, defaults to true. An empty value here will cause Ext.data.Record.isValid to evaluate to... Used for validating a record, defaults to `true`. An empty value here will cause Ext.data.Record.isValid to evaluate to `false`. | Field

convert : Function
A function which converts the value provided by the Reader into an object that will be stored in the Record. It is pa...
A function which converts the value provided by the Reader into an object that will be stored in the Record. It is passed the following parameters:

- v : Mixed
  The data value as read by the Reader, if undefined will use the configured `defaultValue`.
- rec : Mixed
  The data object containing the row as read by the Reader. Depending on the Reader type, this could be an Array (ArrayReader), an object (JsonReader), or an XML element (XMLReader).

    // example of convert function
    function fullName(v, record){
        return record.name.last + ', ' + record.name.first;
    }

    function location(v, record){
        return !record.city ? '' : (record.city + ', ' + record.state);
    }

    var Dude = Ext.data.Record.create([
        {name: 'fullname',  convert: fullName},
        {name: 'firstname', mapping: 'name.first'},
        {name: 'lastname',  mapping: 'name.last'},
        {name: 'city', defaultValue: 'homeless'},
        'state',
        {name: 'location',  convert: location}
    ]);

    // create the data store
    var store = new Ext.data.Store({
        reader: new Ext.data.JsonReader(
            {
                idProperty: 'key',
                root: 'daRoot',
                totalProperty: 'total'
            },
            Dude  // recordType
        )
    });

    var myData = [
        { key: 1,
          name: { first: 'Fat',    last:  'Albert' }
          // notice no city, state provided in data object
        },
        { key: 2,
          name: { first: 'Barney', last:  'Rubble' },
          city: 'Bedrock', state: 'Stoneridge'
        },
        { key: 3,
          name: { first: 'Cliff',  last:  'Claven' },
          city: 'Boston',  state: 'MA'
        }
    ];

Field

dateFormat : String
(Optional) Used when converting received data into a Date when the type is specified as "date". A format string for t...

(Optional) Used when converting received data into a Date when the type is specified as `"date"`.

A format string for the Date.parseDate function, or "timestamp" if the value provided by the Reader is a UNIX timestamp, or "time" if the value provided by the Reader is a javascript millisecond timestamp. See Date

Field

| defaultValue : Mixed The default value used when a Record is being created by a Reader when the item referenced by the mapping does not ex... The default value used when a Record is being created by a Reader when the item referenced by the `mapping` does not exist in the data object (i.e. undefined). (defaults to "") | Field

mapping : String/Number
(Optional) A path expression for use by the Ext.data.DataReader implementation that is creating the Record to extract...

(Optional) A path expression for use by the Ext.data.DataReader implementation that is creating the Record to extract the Field value from the data object. If the path expression is the same as the field name, the mapping may be omitted.

The form of the mapping expression depends on the Reader being used.

- Ext.data.JsonReader
  The mapping is a string containing the javascript expression to reference the data from an element of the data item's root Array. Defaults to the field name.
- Ext.data.XmlReader
  The mapping is an Ext.DomQuery path to the data item relative to the DOM element that represents the record. Defaults to the field name.
- Ext.data.ArrayReader
  The mapping is a number indicating the Array index of the field's value. Defaults to the field specification's Array position.

If a more complex value extraction strategy is required, then configure the Field with a convert function. This is passed the whole row object, and may interrogate it in whatever way is necessary in order to return the desired data.

Field

name : String
The name by which the field is referenced within the Record. This is referenced by, for example, the dataIndex proper...
The name by which the field is referenced within the Record. This is referenced by, for example, the `dataIndex` property in column definition objects passed to Ext.grid.ColumnModel.

Note: In the simplest case, if no properties other than `name` are required, a field definition may consist of just a String for the field name.

Field

| sortDir : String Initial direction to sort (`"ASC"` or `"DESC"`). Defaults to `"ASC"`. | Field

sortType : Function
A function which converts a Field's value to a comparable value in order to ensure correct sort ordering. Predefined ...
A function which converts a Field's value to a comparable value in order to ensure correct sort ordering. Predefined functions are provided in Ext.data.SortTypes. A custom sort example:

    // current sort     after sort we want
    // +-+------+          +-+------+
    // |1|First |          |1|First |
    // |2|Last  |          |3|Second|
    // |3|Second|          |2|Last  |
    // +-+------+          +-+------+

    sortType: function(value) {
       switch (value.toLowerCase()) // native toLowerCase():
       {
          case 'first': return 1;
          case 'second': return 2;
          default: return 3;
       }
    }

Field

type : Mixed
The data type for automatic conversion from received data to the stored value if convert has not been specified. This...
The data type for automatic conversion from received data to the stored value if `convert` has not been specified. This may be specified as a string value. Possible values are

- auto (Default, implies no conversion)
- string
- int
- float
- boolean
- date

This may also be specified by referencing a member of the Ext.data.Types class.

Developers may create their own application-specific data types by defining new members of the Ext.data.Types class.

Field

| useNull : Boolean (Optional) Use when converting received data into a Number type (either int or float). If the value cannot be parsed,... (Optional) Use when converting received data into a Number type (either int or float). If the value cannot be parsed, null will be used if useNull is true, otherwise the value will be 0. Defaults to `false` | Field

## Public Properties

This class has no public properties.

## Public Methods

This class has no public methods.

## Public Events

This class has no public events.